package com.hzs.common.security.service;

import com.hzs.common.core.constant.CacheConstants;
import com.hzs.common.core.constant.SecurityConstants;
import com.hzs.common.core.service.RedisService;
import com.hzs.common.core.utils.JwtUtils;
import com.hzs.common.core.utils.ServletUtils;
import com.hzs.common.core.utils.StringUtils;
import com.hzs.common.core.utils.ip.IpUtils;
import com.hzs.common.core.utils.uuid.IdUtils;
import com.hzs.common.domain.member.ext.CuMemberExt;
import com.hzs.common.security.utils.SecurityUtils;
import com.hzs.member.base.dto.LoginMember;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.TimeUnit;

/**
 * token验证处理
 */
@Slf4j
@Component
public class MemberTokenService {

    @Autowired
    private RedisService redisService;

    /**
     * 毫秒->秒
     */
    protected static final long MILLIS_SECOND = 1000;
    /**
     * 毫秒->分钟
     */
    protected static final long MILLIS_MINUTE = 60 * MILLIS_SECOND;
    /**
     * 到期时间
     */
    private final static long EXPIRE_TIME = CacheConstants.MEMBER_LOGIN_TOKEN_EXPIRATION;
    /**
     * 缓存前缀
     */
    private final static String ACCESS_TOKEN = CacheConstants.LOGIN_TOKEN_KEY;
    /**
     * 刷新缓存时间
     */
    private final static Long MILLIS_MINUTE_TEN = CacheConstants.MEMBER_LOGIN_TOKEN_REFRESH_TIME * MILLIS_MINUTE;

    /**
     * 创建令牌
     */
    public Map<String, Object> createToken(LoginMember loginMember) {
        String token = IdUtils.fastUUID();

        // 注册用户处理
        CuMemberExt cuMember = loginMember.getCuMember();
        // 用户ID
        Long pkId = cuMember.getPkId();
        // 用户编号
        String memberCode = cuMember.getMemberCode();
        // 结算国
        Integer pkCountry = cuMember.getPkSettleCountry();
        // 系统类型
        Integer systemType = cuMember.getSystemType();

        loginMember.setToken(token);
        loginMember.setPkId(pkId);
        loginMember.setMemberCode(memberCode);
        loginMember.setIpaddr(IpUtils.getIpAddr(ServletUtils.getRequest()));

        refreshToken(loginMember);

        // Jwt存储信息
        Map<String, Object> claimsMap = new HashMap<>();
        claimsMap.put(SecurityConstants.USER_KEY, token);
        claimsMap.put(SecurityConstants.DETAILS_USER_ID, pkId);
        claimsMap.put(SecurityConstants.DETAILS_USERNAME, memberCode);
        claimsMap.put(SecurityConstants.DETAILS_USER_TYPE, loginMember.getLoginType());
        claimsMap.put(SecurityConstants.DETAILS_USER_COUNTRY, pkCountry);
        claimsMap.put(SecurityConstants.SYSTEM_TYPE, systemType);

        // 接口返回信息
        Map<String, Object> rspMap = new HashMap<>();
        rspMap.put("access_token", JwtUtils.createToken(claimsMap));
        rspMap.put("expires_in", EXPIRE_TIME);
        return rspMap;
    }

    /**
     * 获取用户身份信息
     *
     * @return 用户信息
     */
    public LoginMember getLoginMember() {
        return getLoginMember(ServletUtils.getRequest());
    }

    /**
     * 获取用户身份信息
     *
     * @return 用户信息
     */
    public LoginMember getLoginMember(HttpServletRequest request) {
        // 获取请求携带的令牌
        String token = SecurityUtils.getToken(request);
        return getLoginMember(token);
    }

    /**
     * 获取用户身份信息
     *
     * @return 用户信息
     */
    public LoginMember getLoginMember(String token) {
        try {
            if (StringUtils.isNotEmpty(token)) {
                String userKey = JwtUtils.getUserKey(token);
                return redisService.getCacheObject(getTokenKey(userKey));
            }
        } catch (Exception e) {
            log.error("获取用户信息解析异常! e: {}", e.getMessage());
        }
        return null;
    }

    /**
     * 删除用户缓存信息
     */
    public void delLoginMember(String token) {
        if (StringUtils.isNotEmpty(token)) {
            String userKey = JwtUtils.getUserKey(token);
            redisService.deleteObject(getTokenKey(userKey));
        }
    }

    /**
     * 验证令牌有效期，相差不足120分钟，自动刷新缓存
     *
     * @param loginMember 登录会员信息
     */
    public void verifyToken(LoginMember loginMember) {
        long expireTime = loginMember.getExpireTime();
        long currentTime = System.currentTimeMillis();

        if (expireTime - currentTime <= MILLIS_MINUTE_TEN) {
            refreshToken(loginMember);
        }
    }

    /**
     * 刷新令牌有效期
     *
     * @param loginMember 登录信息
     */
    public void refreshToken(LoginMember loginMember) {
        // 超时时间（分钟）
        long tmpExpireTime = EXPIRE_TIME;

        loginMember.setLoginTime(System.currentTimeMillis());
        loginMember.setExpireTime(loginMember.getLoginTime() + tmpExpireTime * MILLIS_MINUTE);

        // 根据uuid将loginUser缓存
        String userKey = getTokenKey(loginMember.getToken());
        redisService.setCacheObject(userKey, loginMember, tmpExpireTime, TimeUnit.MINUTES);
    }

    private String getTokenKey(String token) {
        return ACCESS_TOKEN + token;
    }

}
